



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Hadoop学习笔记—20.网站日志分析项目案例（二）数据清洗</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Hadoop学习笔记—20.网站日志分析项目案例（二）数据清洗</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 06:44:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>网站日志分析项目案例（一）项目介绍：<a href="http://www.cnblogs.com/edisonchou/p/4449082.html" rel="external nofollow noreferrer">http://www.cnblogs.com/edisonchou/p/4449082.html</a></p>
<p>网站日志分析项目案例（二）数据清洗：<strong>当前页面</strong></p>
<p>网站日志分析项目案例（三）统计分析：<a href="http://www.cnblogs.com/edisonchou/p/4464349.html" rel="external nofollow noreferrer">http://www.cnblogs.com/edisonchou/p/4464349.html</a></p></blockquote>
<h1>一、数据情况分析</h1>
<h2>1.1 数据情况回顾</h2>
<p>　　该论坛数据有两部分：</p>
<p>　　（1）历史数据约56GB，统计到2012-05-29。这也说明，在2012-05-29之前，日志文件都在一个文件里边，采用了追加写入的方式。</p>
<p>　　（2）自2013-05-30起，每天生成一个数据文件，约150MB左右。这也说明，从2013-05-30之后，日志文件不再是在一个文件里边。</p>
<p>　　图1展示了该日志数据的记录格式，其中每行记录有5部分组成：访问者IP、访问时间、访问资源、访问状态（HTTP状态码）、本次访问流量。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/381412/201504/222351176717227.png" /></p>
<p>图1 日志记录数据格式</p>
<p>　　本次使用数据来自于两个2013年的日志文件，分别为access_2013_05_30.log与access_2013_05_31.log，下载地址为：<a href="http://pan.baidu.com/s/1pJE7XR9" rel="external nofollow noreferrer">http://pan.baidu.com/s/1pJE7XR9</a></p>
<h2>1.2 要清理的数据</h2>
<p>　　（1）根据前一篇的关键指标的分析，我们所要统计分析的均不涉及到访问状态（HTTP状态码）以及本次访问的流量，于是我们首先可以将这两项记录清理掉；</p>
<p>　　（2）根据日志记录的数据格式，我们需要将日期格式转换为平常所见的普通格式如20150426这种，于是我们可以写一个类将日志记录的日期进行转换；</p>
<p>　　（3）由于静态资源的访问请求对我们的数据分析没有意义，于是我们可以将"GET /staticsource/"开头的访问记录过滤掉，又因为GET和POST字符串对我们也没有意义，因此也可以将其省略掉；</p>
<h1>二、数据清洗过程</h1>
<h2>2.1 定期上传日志至HDFS</h2>
<p>　　首先，把日志数据上传到HDFS中进行处理，可以分为以下几种情况：</p>
<p>　　（1）如果是日志服务器数据较小、压力较小，可以直接使用shell命令把数据上传到HDFS中；</p>
<p>　　（2）如果是日志服务器数据较大、压力较大，使用NFS在另一台服务器上上传数据；</p>
<p>　　（3）如果日志服务器非常多、数据量大，使用flume进行数据处理；</p>
<p>　　这里我们的实验数据文件较小，因此直接采用第一种Shell命令方式。又因为日志文件时每天产生的，因此需要设置一个定时任务，在第二天的1点钟自动将前一天产生的log文件上传到HDFS的指定目录中。所以，我们通过shell脚本结合crontab创建一个定时任务techbbs_core.sh，内容如下：</p>
<blockquote><p>#!/bin/sh</p>
<p>#step1.get yesterday format string<br />yesterday=$(date --date='1 days ago' +%Y_%m_%d)<br />#step2.upload logs to hdfs<br />hadoop fs -put /usr/local/files/apache_logs/access_${yesterday}.log /project/techbbs/data</p></blockquote>
<p>　　结合crontab设置为每天1点钟自动执行的定期任务：crontab -e，内容如下（其中1代表每天1:00，techbbs_core.sh为要执行的脚本文件）：</p>
<blockquote><p>* 1 * * * techbbs_core.sh</p></blockquote>
<p>　　验证方式：通过命令 crontab -l 可以查看已经设置的定时任务</p>
<h2>2.2 编写MapReduce程序清理日志</h2>
<p>　　（1）编写日志解析类对每行记录的五个组成部分进行单独的解析</p>
<div>
<pre class="prettyprint linenums">    static class LogParser {<br />
        public static final SimpleDateFormat FORMAT = new SimpleDateFormat(<br />
                "d/MMM/yyyy:HH:mm:ss", Locale.ENGLISH);<br />
        public static final SimpleDateFormat dateformat1 = new SimpleDateFormat(<br />
                "yyyyMMddHHmmss");/**<br />
         * 解析英文时间字符串<br />
         *<br />
         * @param string<br />
         * @return<br />
         * @throws ParseException<br />
         */<br />
        private Date parseDateFormat(String string) {<br />
            Date parse = null;<br />
            try {<br />
                parse = FORMAT.parse(string);<br />
            } catch (ParseException e) {<br />
                e.printStackTrace();<br />
            }<br />
            return parse;<br />
        }

        /**<br />
         * 解析日志的行记录<br />
         *<br />
         * @param line<br />
         * @return 数组含有5个元素，分别是ip、时间、url、状态、流量<br />
         */<br />
        public String[] parse(String line) {<br />
            String ip = parseIP(line);<br />
            String time = parseTime(line);<br />
            String url = parseURL(line);<br />
            String status = parseStatus(line);<br />
            String traffic = parseTraffic(line);

            return new String[] { ip, time, url, status, traffic };<br />
        }

        private String parseTraffic(String line) {<br />
            final String trim = line.substring(line.lastIndexOf("\"") + 1)<br />
                    .trim();<br />
            String traffic = trim.split(" ")[1];<br />
            return traffic;<br />
        }

        private String parseStatus(String line) {<br />
            final String trim = line.substring(line.lastIndexOf("\"") + 1)<br />
                    .trim();<br />
            String status = trim.split(" ")[0];<br />
            return status;<br />
        }

        private String parseURL(String line) {<br />
            final int first = line.indexOf("\"");<br />
            final int last = line.lastIndexOf("\"");<br />
            String url = line.substring(first + 1, last);<br />
            return url;<br />
        }

        private String parseTime(String line) {<br />
            final int first = line.indexOf("[");<br />
            final int last = line.indexOf("+0800]");<br />
            String time = line.substring(first + 1, last).trim();<br />
            Date date = parseDateFormat(time);<br />
            return dateformat1.format(date);<br />
        }

        private String parseIP(String line) {<br />
            String ip = line.split("- -")[0].trim();<br />
            return ip;<br />
        }<br />
    }</pre>
</div>
<p>　　（2）编写MapReduce程序对指定日志文件的所有记录进行过滤</p>
<p>　　Mapper类：</p>
<div>
<pre class="prettyprint linenums">        static class MyMapper extends<br />
            Mapper&lt;LongWritable, Text, LongWritable, Text&gt; {<br />
        LogParser logParser = new LogParser();<br />
        Text outputValue = new Text();

        protected void map(<br />
                LongWritable key,<br />
                Text value,<br />
                org.apache.hadoop.mapreduce.Mapper&lt;LongWritable, Text, LongWritable, Text&gt;.Context context)<br />
                throws java.io.IOException, InterruptedException {<br />
            final String[] parsed = logParser.parse(value.toString());

            // step1.过滤掉静态资源访问请求<br />
            if (parsed[2].startsWith("GET /static/")<br />
                    || parsed[2].startsWith("GET /uc_server")) {<br />
                return;<br />
            }<br />
            // step2.过滤掉开头的指定字符串<br />
            if (parsed[2].startsWith("GET /")) {<br />
                parsed[2] = parsed[2].substring("GET /".length());<br />
            } else if (parsed[2].startsWith("POST /")) {<br />
                parsed[2] = parsed[2].substring("POST /".length());<br />
            }<br />
            // step3.过滤掉结尾的特定字符串<br />
            if (parsed[2].endsWith(" HTTP/1.1")) {<br />
                parsed[2] = parsed[2].substring(0, parsed[2].length()<br />
                        - " HTTP/1.1".length());<br />
            }<br />
            // step4.只写入前三个记录类型项<br />
            outputValue.set(parsed[0] + "\t" + parsed[1] + "\t" + parsed[2]);<br />
            context.write(key, outputValue);<br />
        }<br />
    }</pre>
</div>
<p>　　Reducer类：</p>
<div>
<pre class="prettyprint linenums">    static class MyReducer extends<br />
            Reducer&lt;LongWritable, Text, Text, NullWritable&gt; {<br />
        protected void reduce(<br />
                LongWritable k2,<br />
                java.lang.Iterable&lt;Text&gt; v2s,<br />
                org.apache.hadoop.mapreduce.Reducer&lt;LongWritable, Text, Text, NullWritable&gt;.Context context)<br />
                throws java.io.IOException, InterruptedException {<br />
            for (Text v2 : v2s) {<br />
                context.write(v2, NullWritable.get());<br />
            }<br />
        };<br />
    }</pre>
</div>
<p>　　（3）LogCleanJob.java的完整示例代码</p>
<div>
<div>
<pre class="prettyprint linenums">package techbbs;

import java.net.URI;<br />
import java.text.ParseException;<br />
import java.text.SimpleDateFormat;<br />
import java.util.Date;<br />
import java.util.Locale;

import org.apache.hadoop.conf.Configuration;<br />
import org.apache.hadoop.conf.Configured;<br />
import org.apache.hadoop.fs.FileSystem;<br />
import org.apache.hadoop.fs.Path;<br />
import org.apache.hadoop.io.LongWritable;<br />
import org.apache.hadoop.io.NullWritable;<br />
import org.apache.hadoop.io.Text;<br />
import org.apache.hadoop.mapreduce.Job;<br />
import org.apache.hadoop.mapreduce.Mapper;<br />
import org.apache.hadoop.mapreduce.Reducer;<br />
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;<br />
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;<br />
import org.apache.hadoop.util.Tool;<br />
import org.apache.hadoop.util.ToolRunner;

public class LogCleanJob extends Configured implements Tool {

    public static void main(String[] args) {<br />
        Configuration conf = new Configuration();<br />
        try {<br />
            int res = ToolRunner.run(conf, new LogCleanJob(), args);<br />
            System.exit(res);<br />
        } catch (Exception e) {<br />
            e.printStackTrace();<br />
        }<br />
    }

    @Override<br />
    public int run(String[] args) throws Exception {<br />
        final Job job = new Job(new Configuration(),<br />
                LogCleanJob.class.getSimpleName());<br />
        // 设置为可以打包运行<br />
        job.setJarByClass(LogCleanJob.class);<br />
        FileInputFormat.setInputPaths(job, args[0]);<br />
        job.setMapperClass(MyMapper.class);<br />
        job.setMapOutputKeyClass(LongWritable.class);<br />
        job.setMapOutputValueClass(Text.class);<br />
        job.setReducerClass(MyReducer.class);<br />
        job.setOutputKeyClass(Text.class);<br />
        job.setOutputValueClass(NullWritable.class);<br />
        FileOutputFormat.setOutputPath(job, new Path(args[1]));<br />
        // 清理已存在的输出文件<br />
        FileSystem fs = FileSystem.get(new URI(args[0]), getConf());<br />
        Path outPath = new Path(args[1]);<br />
        if (fs.exists(outPath)) {<br />
            fs.delete(outPath, true);<br />
        }

        boolean success = job.waitForCompletion(true);<br />
        if(success){<br />
            System.out.println("Clean process success!");<br />
        }<br />
        else{<br />
            System.out.println("Clean process failed!");<br />
        }<br />
        return 0;<br />
    }

    static class MyMapper extends<br />
            Mapper&lt;LongWritable, Text, LongWritable, Text&gt; {<br />
        LogParser logParser = new LogParser();<br />
        Text outputValue = new Text();

        protected void map(<br />
                LongWritable key,<br />
                Text value,<br />
                org.apache.hadoop.mapreduce.Mapper&lt;LongWritable, Text, LongWritable, Text&gt;.Context context)<br />
                throws java.io.IOException, InterruptedException {<br />
            final String[] parsed = logParser.parse(value.toString());

            // step1.过滤掉静态资源访问请求<br />
            if (parsed[2].startsWith("GET /static/")<br />
                    || parsed[2].startsWith("GET /uc_server")) {<br />
                return;<br />
            }<br />
            // step2.过滤掉开头的指定字符串<br />
            if (parsed[2].startsWith("GET /")) {<br />
                parsed[2] = parsed[2].substring("GET /".length());<br />
            } else if (parsed[2].startsWith("POST /")) {<br />
                parsed[2] = parsed[2].substring("POST /".length());<br />
            }<br />
            // step3.过滤掉结尾的特定字符串<br />
            if (parsed[2].endsWith(" HTTP/1.1")) {<br />
                parsed[2] = parsed[2].substring(0, parsed[2].length()<br />
                        - " HTTP/1.1".length());<br />
            }<br />
            // step4.只写入前三个记录类型项<br />
            outputValue.set(parsed[0] + "\t" + parsed[1] + "\t" + parsed[2]);<br />
            context.write(key, outputValue);<br />
        }<br />
    }

    static class MyReducer extends<br />
            Reducer&lt;LongWritable, Text, Text, NullWritable&gt; {<br />
        protected void reduce(<br />
                LongWritable k2,<br />
                java.lang.Iterable&lt;Text&gt; v2s,<br />
                org.apache.hadoop.mapreduce.Reducer&lt;LongWritable, Text, Text, NullWritable&gt;.Context context)<br />
                throws java.io.IOException, InterruptedException {<br />
            for (Text v2 : v2s) {<br />
                context.write(v2, NullWritable.get());<br />
            }<br />
        };<br />
    }

    /*<br />
     * 日志解析类<br />
     */<br />
    static class LogParser {<br />
        public static final SimpleDateFormat FORMAT = new SimpleDateFormat(<br />
                "d/MMM/yyyy:HH:mm:ss", Locale.ENGLISH);<br />
        public static final SimpleDateFormat dateformat1 = new SimpleDateFormat(<br />
                "yyyyMMddHHmmss");

        public static void main(String[] args) throws ParseException {<br />
            final String S1 = "27.19.74.143 - - [30/May/2013:17:38:20 +0800] \"GET /static/image/common/faq.gif HTTP/1.1\" 200 1127";<br />
            LogParser parser = new LogParser();<br />
            final String[] array = parser.parse(S1);<br />
            System.out.println("样例数据： " + S1);<br />
            System.out.format(<br />
                    "解析结果：  ip=%s, time=%s, url=%s, status=%s, traffic=%s",<br />
                    array[0], array[1], array[2], array[3], array[4]);<br />
        }

        /**<br />
         * 解析英文时间字符串<br />
         *<br />
         * @param string<br />
         * @return<br />
         * @throws ParseException<br />
         */<br />
        private Date parseDateFormat(String string) {<br />
            Date parse = null;<br />
            try {<br />
                parse = FORMAT.parse(string);<br />
            } catch (ParseException e) {<br />
                e.printStackTrace();<br />
            }<br />
            return parse;<br />
        }

        /**<br />
         * 解析日志的行记录<br />
         *<br />
         * @param line<br />
         * @return 数组含有5个元素，分别是ip、时间、url、状态、流量<br />
         */<br />
        public String[] parse(String line) {<br />
            String ip = parseIP(line);<br />
            String time = parseTime(line);<br />
            String url = parseURL(line);<br />
            String status = parseStatus(line);<br />
            String traffic = parseTraffic(line);

            return new String[] { ip, time, url, status, traffic };<br />
        }

        private String parseTraffic(String line) {<br />
            final String trim = line.substring(line.lastIndexOf("\"") + 1)<br />
                    .trim();<br />
            String traffic = trim.split(" ")[1];<br />
            return traffic;<br />
        }

        private String parseStatus(String line) {<br />
            final String trim = line.substring(line.lastIndexOf("\"") + 1)<br />
                    .trim();<br />
            String status = trim.split(" ")[0];<br />
            return status;<br />
        }

        private String parseURL(String line) {<br />
            final int first = line.indexOf("\"");<br />
            final int last = line.lastIndexOf("\"");<br />
            String url = line.substring(first + 1, last);<br />
            return url;<br />
        }

        private String parseTime(String line) {<br />
            final int first = line.indexOf("[");<br />
            final int last = line.indexOf("+0800]");<br />
            String time = line.substring(first + 1, last).trim();<br />
            Date date = parseDateFormat(time);<br />
            return dateformat1.format(date);<br />
        }

        private String parseIP(String line) {<br />
            String ip = line.split("- -")[0].trim();<br />
            return ip;<br />
        }<br />
    }<br />
}</pre>
</div>
</div>
<p>　　（4）导出jar包，并将其上传至Linux服务器指定目录中</p>
<h2>2.3&nbsp;定期清理日志至HDFS</h2>
<p>　　这里我们改写刚刚的定时任务脚本，将自动执行清理的MapReduce程序加入脚本中，内容如下：</p>
<blockquote><p>#!/bin/sh</p>
<p>#step1.get yesterday format string<br />yesterday=$(date --date='1 days ago' +%Y_%m_%d)<br />#step2.upload logs to hdfs<br />hadoop fs -put /usr/local/files/apache_logs/access_${yesterday}.log /project/techbbs/data<br /><strong>#step3.clean log data</strong><br /><strong>hadoop jar /usr/local/files/apache_logs/mycleaner.jar /project/techbbs/data/access_${yesterday}.log /project/techbbs/cleaned/${yesterday}</strong></p></blockquote>
<p>　　这段脚本的意思就在于每天1点将日志文件上传到HDFS后，执行数据清理程序对已存入HDFS的日志文件进行过滤，并将过滤后的数据存入cleaned目录下。</p>
<h2>2.4 定时任务测试</h2>
<p>　　（1）因为两个日志文件是2013年的，因此这里将其名称改为2015年当天以及前一天的，以便这里能够测试通过。</p>
<p>　　（2）执行命令：<strong>techbbs_core.sh 2014_04_26</strong></p>
<p><strong>　　</strong>控制台的输出信息如下所示，可以看到过滤后的记录减少了很多：</p>
<blockquote><p>15/04/26 04:27:20 INFO input.FileInputFormat: Total input paths to process : 1<br />15/04/26 04:27:20 INFO util.NativeCodeLoader: Loaded the native-hadoop library<br />15/04/26 04:27:20 WARN snappy.LoadSnappy: Snappy native library not loaded<br />15/04/26 04:27:22 INFO mapred.JobClient: Running job: job_201504260249_0002<br />15/04/26 04:27:23 INFO mapred.JobClient:  map 0% reduce 0%<br />15/04/26 04:28:01 INFO mapred.JobClient:  map 29% reduce 0%<br />15/04/26 04:28:07 INFO mapred.JobClient:  map 42% reduce 0%<br />15/04/26 04:28:10 INFO mapred.JobClient:  map 57% reduce 0%<br />15/04/26 04:28:13 INFO mapred.JobClient:  map 74% reduce 0%<br />15/04/26 04:28:16 INFO mapred.JobClient:  map 89% reduce 0%<br />15/04/26 04:28:19 INFO mapred.JobClient:  map 100% reduce 0%<br />15/04/26 04:28:49 INFO mapred.JobClient:  map 100% reduce 100%<br />15/04/26 04:28:50 INFO mapred.JobClient: Job complete: job_201504260249_0002<br />15/04/26 04:28:50 INFO mapred.JobClient: Counters: 29<br />15/04/26 04:28:50 INFO mapred.JobClient:   Job Counters <br />15/04/26 04:28:50 INFO mapred.JobClient:     Launched reduce tasks=1<br />15/04/26 04:28:50 INFO mapred.JobClient:     <strong>SLOTS_MILLIS_MAPS=58296</strong><br />15/04/26 04:28:50 INFO mapred.JobClient:     Total time spent by all reduces waiting after reserving slots (ms)=0<br />15/04/26 04:28:50 INFO mapred.JobClient:     Total time spent by all maps waiting after reserving slots (ms)=0<br />15/04/26 04:28:50 INFO mapred.JobClient:     Launched map tasks=1<br />15/04/26 04:28:50 INFO mapred.JobClient:     Data-local map tasks=1<br />15/04/26 04:28:50 INFO mapred.JobClient:     <strong>SLOTS_MILLIS_REDUCES=25238</strong><br />15/04/26 04:28:50 INFO mapred.JobClient:   File Output Format Counters <br />15/04/26 04:28:50 INFO mapred.JobClient:     Bytes Written=12794925<br />15/04/26 04:28:50 INFO mapred.JobClient:   FileSystemCounters<br />15/04/26 04:28:50 INFO mapred.JobClient:     FILE_BYTES_READ=14503530<br />15/04/26 04:28:50 INFO mapred.JobClient:     HDFS_BYTES_READ=61084325<br />15/04/26 04:28:50 INFO mapred.JobClient:     FILE_BYTES_WRITTEN=29111500<br />15/04/26 04:28:50 INFO mapred.JobClient:     HDFS_BYTES_WRITTEN=12794925<br />15/04/26 04:28:50 INFO mapred.JobClient:   File Input Format Counters <br />15/04/26 04:28:50 INFO mapred.JobClient:     Bytes Read=61084192<br />15/04/26 04:28:50 INFO mapred.JobClient:   Map-Reduce Framework<br />15/04/26 04:28:50 INFO mapred.JobClient:     Map output materialized bytes=14503530<br />15/04/26 04:28:50 INFO mapred.JobClient:     Map input records=548160<br />15/04/26 04:28:50 INFO mapred.JobClient:     Reduce shuffle bytes=14503530<br />15/04/26 04:28:50 INFO mapred.JobClient:     Spilled Records=339714<br />15/04/26 04:28:50 INFO mapred.JobClient:     Map output bytes=14158741<br />15/04/26 04:28:50 INFO mapred.JobClient:     CPU time spent (ms)=21200<br />15/04/26 04:28:50 INFO mapred.JobClient:     Total committed heap usage (bytes)=229003264<br />15/04/26 04:28:50 INFO mapred.JobClient:     Combine input records=0<br />15/04/26 04:28:50 INFO mapred.JobClient:     SPLIT_RAW_BYTES=133<br />15/04/26 04:28:50 INFO mapred.JobClient:     Reduce input records=169857<br />15/04/26 04:28:50 INFO mapred.JobClient:     Reduce input groups=169857<br />15/04/26 04:28:50 INFO mapred.JobClient:     Combine output records=0<br />15/04/26 04:28:50 INFO mapred.JobClient:     Physical memory (bytes) snapshot=154001408<br />15/04/26 04:28:50 INFO mapred.JobClient:     <strong>Reduce output records=169857</strong><br />15/04/26 04:28:50 INFO mapred.JobClient:     Virtual memory (bytes) snapshot=689442816<br />15/04/26 04:28:50 INFO mapred.JobClient:     <strong>Map output records=169857</strong><br />Clean process success!</p></blockquote>
<p>　　（3）通过Web接口查看HDFS中的日志数据：</p>
<p>　　存入的未过滤的日志数据：/project/techbbs/data/</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/381412/201504/262019284316490.png" /></p>
<p>　　存入的已过滤的日志数据：/project/techbbs/cleaned/</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/381412/201504/262019432447964.png" /></p>
<div>
<p>作者：<a href="http://www.cnblogs.com/edisonchou/" rel="external nofollow noreferrer">周旭龙</a></p>
<p>出处：<a href="http://www.cnblogs.com/edisonchou/" rel="external nofollow noreferrer">http://www.cnblogs.com/edisonchou/</a></p>
<p>本文版权归作者和博客园共有，欢迎转载，但未经作者同意必须保留此段声明，且在文章页面明显位置给出原文链接。</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4p7p0q.html">FFmpeg编译找不到库文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rnmjdq.html">【2016-11-7】【坚持学习】【Day22】【Oracle 分页查询】</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z6xovq.html">Oracle第三方ado&period;net数据提供程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8znyjv8.html">Lambert漫反射&period;BLinnPhong及Phong模型 Unity自带的在Lighting&period;cginc里</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xpep08.html">poj -2229 Sumsets （dp）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v6mx38.html">一个js编写全选、弹出对话框、ajax-json的案例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjvmxk8.html">vs2012代码段，快捷键，snippet 的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mjkp48.html">UVa 10911 - Forming Quiz Teams</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zl6z19.html">蓝桥网试题 java 基础练习 矩阵乘法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mep55oq.html">PT20150801隆重开班</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzd0xg8.html">【记录】Spring项目转化为Spring Web项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z6og59.html">Python学习&lowbar;06&lowbar;文件、IO</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yr41r8.html">Menu-多级菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo7k61q.html">js打印小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r54n7rq.html">敏捷与CMM的恩怨</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyrg719.html">快速傅里叶变换&lpar;FFT&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppn6oy9.html">Scrapy持久化存储</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvev32o9.html">python垃圾回收三之标记清除</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnjk7jq.html">FastReport&period;Net 入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv623mq.html">ManualResetEvent</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/390mlxn8.html">&lpar;UWP开发&rpar;更为合理的一种ListView下拉刷新&lpar;PullToRefresh&rpar;实现方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4zw0j9.html">谈谈iOS中的屏幕方向</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv1prxq.html">Mybatis拦截器</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxkjxj8.html">c语言结构体</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zon73q.html">fly bird</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwjgvy8.html">linux系统CentOS7</a>
			</li>
						<li><a href="https://www.batexi.com/a/49ge70e8.html">转：Webpack 指南（整理 草稿）</a>
			</li>
						<li><a href="https://www.batexi.com/a/390m3on8.html">&lbrack;面试&rsqb; Design Questions</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4zoej9.html">dom4j解析示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ojejeq.html">Python列表和元组</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
